#include <stdio.h>
#include "vid.h"
#include "term.h"
#include <asmops.h>
#include "segm.h"
#include "intr.h"

void kmain(void)
{
	clear_scr();
	puts("kernel starting up");

	set_text_color(YELLOW);
	puts("<initialization code goes here>");
	set_text_color(LTGRAY);
	puts("hello world!");

	/* initialize segments */
	init_segm();
	/* initialize interrupt handling */
	init_intr();

	/* trigger a software interrupt, just for testing */
	asm volatile("int $0x80");

	for(;;) {
		halt_cpu(); /* interrupts will wake it up */
	}
}
